
/* Amino distance header file -- Peter N. Yianilos 1996.
   Part of a joint project with David Loewenstern. */

#define SELECT_H1(x) ( (x) & 0x000003ff)
#define SELECT_H2(x) (((x) & 0x000ffc00) >> 10)
#define SELECT_H3(x) (((x) & 0x3ff00000) >> 20)

#define SET_H(v1,v2,v3) ((v1) | ((v2)<<10) | ((v3)<<20))

typedef struct {
	int hamming_increment;
	int next_state;
} FINAL_ENTRY;

FINAL_ENTRY **build_final_decoder(void);
void destroy_final_decoder(FINAL_ENTRY **ffsm);
void print_final_decoder(FINAL_ENTRY **ffsm);




